<?php
// Globaler Variablenbereich
$GameTime	= 200;	// all Games over in 200 sec
$Frac 		= 3; // Number of fractions, the moves are split into
$Divider	= 10;	// The devided part, that will be count up each time $Demo is incrased
$TimeElapsed 	= $_GET["Demo"]; if($TimeElapsed=="") { $TimeElapsed = round(rand(1,20))*5; }
$UpdateInterval	= $_GET["UpdateInterval"]; if ($UpdateInterval=="") {$UpdateInterval = 5; }
$DefaultTime	= $_GET["DefaultTime"];    if ($DefaultTime == "") { $DefaultTime = "1:40:00"; };
$Tags		= array(); $PgnText=array();
$PgnIn 		= "ichess.pgn";
$MaxTime	= 150;
$NoPrint 	= false;
$TestPrint 	= false;

function PrintOut ($Text,$IsComment) {
	global $NoPrint,$TestPrint;
	if ($NoPrint) return;
	if ($IsComment && ! $TestPrint) return; 
	if ($IsComment) echo "<i style='color:gray'>".$Text."</i><br>";
	else echo $Text;
}

function ParsePGN($FName) {
	global $Tags, $PgnText;
	$Results = array ("*", "1/2-1/2", "1-0", "0-1");
	$b = file ( $FName );
	$g = implode(' ',$b);
	$g = explode('[',$g); 
	if (count($g) < 2) return;
	$GameNr=0;$i =0; 
	foreach ($g as $s) { 
		$tag = explode(']',$s);
		if (count($tag) <2) continue;
		$Tags[$GameNr][$i]=$tag[0];
		$i++;
		$pgn=$tag[1];
		foreach ($Results as $result) {
			$pos=strpos($pgn, $result);
			if ($pos) { 
				$PgnText[$GameNr]=substr($pgn,0,$pos).$result;
				$GameNr++; $i=0;
			}
		}
	}
	return;
}


function SimServerDelay ( $Delay_ms) {
	sleep($Delay_ms / 1000);  // simulate 1 sec of "server delay"
}

function PrintTags($GameNr) {
	global $Tags;
	foreach ( array_keys($Tags[$GameNr]) as $ind) PrintOut('['.$Tags[$GameNr][$ind].']<br>',false);
}

function GetDeltaTime ( $NrMoves )  {
	global $TimeElapsed, $Frac, $Divider, $UpdateInterval;
	if ($NrMoves == 0) $NrMoves = 1;
	$g = $TimeElapsed / $NrMoves; 
	$f=$g; if ($f > 1 ) $f = 1;
	$f1 = floor ( floor ($f * $Frac) * $NrMoves/$Frac);
	$g1 = floor( $g * $Divider) * $NrMoves / $Divider; 
	return ( ($g1-$f1));
}

function PrintPGN ( $GameNr ) {
	global $PgnText,$TimeElapsed, $Frac, $MaxTime, $DefaultTime,$UpdateInterval;
	$g = split('}',$PgnText[$GameNr]);
	$NrMoves = count($g) -1; // This is the total number of moves in the game
	$cm = $TimeElapsed/$MaxTime*$NrMoves;
	if ($UpdateInterval <> 0) { $cm = $TimeElapsed/$UpdateInterval; } else { $cm = $TimeElapsed; };

	$f1 = floor( $cm / $Frac) * $Frac; if ($f1 > $NrMoves ) $f1 = $NrMoves;
	$f2 = floor( $cm ); // this many moves could be already executed
	// now get the fraction of the moves given by $f1
	$dT=($f2-$f1)*$UpdateInterval; // the time difference between the moves made and the "possible" moves (if $frac = 1)
	PrintOut("NrOfMoves: ".$NrMoves." MoveTo=".$f1.";".$f2.";".$cm."; Time for CountDown: ".$dT,true);

	$SubStr="";
	$T1=$DefaultTime;
	if ($f1 > 0) { 
		for ($i =0; $i <$f1; $i++) {
			$SubStr.=$g[$i]."}"; 
			if ($i == ($f1-2)) { 
				$T = explode('{',$g[$i]); $T1=$T[count($T)-1]; 
			}
		}
	}
	$PgnText[$GameNr]=$SubStr;
	PrintOut("{Time used for Countdown:".$T1."; Delta:".$dT."}",true);
	PrintOut($PgnText[$GameNr],false);
	$sec= strtotime($T1) - $dT; if ($sec < 0) $sec = 0;
	PrintOut("<br> * {".date("G:i:s",$sec)."}<br><br>",false);
}

function main () {
	global $Tags, $PgnText, $UpdateInterval, $TimeElapsed,$PgnIn;
	PrintOut("{iChessDemo.php; (c) 2009 F. Fuernhammer; Time Elapsed: ".$TimeElapsed.";}<br>",false);
	ParsePGN($PgnIn);
	for ($GameNr=0; $GameNr < count($PgnText); $GameNr++ ) { 
		PrintTags($GameNr);
		PrintPGN($GameNr);
	}
}
function TestCase() {
	global $NoPrint;
	$NoPrint = true;
	$Loop=10;
	$T1=microtime(true);
	for ($i=0; $i<$Loop; $i++) { main(); }

	echo "DeltaT in MilliSeconds/Loop:".((microtime(true)-$T1)/$Loop*1000);
}
// $TestPrint 	= false;
main();
?>

